【HDU 5316】Magician(线段树)

一开始度错题了,题意是求一段和最大的【子序列】,要求相邻两个元素的位置必须互为奇偶。

这样我们可以使用线段树维护4个值:

一段区间内开头结尾元素为:

奇奇

奇偶

偶奇

偶偶

的最大值

之后在pushup的的时候根据题目所给的意思进行合并。

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define lson (pos<<1)
#define rson (pos<<1|1)
typedef long long LL;
const int maxn = 100005;
const LL  INF =  9999999999999999LL;
int n,m;
struct Node{
    LL oe;
    LL oo;
    LL ee;
    LL eo;
}node[maxn << 2];
LL value[maxn];
Node pushnode(Node p,Node q){
    Node newNode;
    newNode.oe = max(max(p.oe,q.oe),max(p.oo + q.ee,p.oe + q.oe));
    newNode.oo = max(max(p.oo,q.oo),max(p.oo + q.eo,p.oe + q.oo));
    newNode.ee = max(max(p.ee,q.ee),max(p.eo + q.ee,p.ee + q.oe));
    newNode.eo = max(max(p.eo,q.eo),max(p.eo + q.eo,p.ee + q.oo));
    return newNode;
}
void pushup(int pos){
    node[pos].oe = max(max(node[lson].oe,node[rson].oe),max(node[lson].oo + node[rson].ee,node[lson].oe + node[rson].oe));
    node[pos].oo = max(max(node[lson].oo,node[rson].oo),max(node[lson].oo + node[rson].eo,node[lson].oe + node[rson].oo));
    node[pos].ee = max(max(node[lson].ee,node[rson].ee),max(node[lson].eo + node[rson].ee,node[lson].ee + node[rson].oe));
    node[pos].eo = max(max(node[lson].eo,node[rson].eo),max(node[lson].eo + node[rson].eo,node[lson].ee + node[rson].oo));
}
void build(int l,int r,int pos){
    if(l == r){
        if(l & 1){
            node[pos].oe = node[pos].ee = node[pos].eo = -INF;
            node[pos].oo = value[l];
        }
        else{
            node[pos].oe = node[pos].oo = node[pos].eo = -INF;
            node[pos].ee = value[l];
        }
        return;
    }
    int mid = (l + r) >> 1;
    build(l,mid,lson);
    build(mid + 1,r,rson);
    pushup(pos);
}
void update(int l,int r,int pos,int to,int v){
    if(l == r){
        if(l & 1){
            node[pos].oe = node[pos].ee = node[pos].eo = -INF;
            node[pos].oo = v;
        }
        else{
            node[pos].oe = node[pos].oo = node[pos].eo = -INF;
            node[pos].ee = v;
        }
        return;
    }
    int mid = (l + r) >> 1;
    if(to <= mid)
        update(l,mid,lson,to,v);
    else
        update(mid + 1,r,rson,to,v);
    pushup(pos);
}
Node query(int l,int r,int L,int R,int pos){
    if(L <= l && r <= R){
        return node[pos];
    }
    int mid = (l + r) >> 1;
    if(R <= mid)
        return query(l,mid,L,R,lson);
    else if(L > mid)
        return query(mid + 1,r,L,R,rson);
    else{
        Node v1 = query(l,mid,L,R,lson);
        Node v2 = query(mid + 1,r,L,R,rson);
        return pushnode(v1,v2);
    }
}
int main(){
    int T;
    scanf("%d",&T);
    while(T--){
        scanf("%d%d",&n,&m);
        for(int i = 1; i <= n; i++){
            scanf("%I64d",&value[i]);
        }
        build(1,n,1);
        for(int i = 0; i < m; i++){
            int op;
            LL  a,b;
            scanf("%d%I64d%I64d",&op,&a,&b);
            if(op == 0){
                Node nans = query(1,n,a,b,1);
                LL ans = max(max(nans.oo,nans.eo),max(nans.ee,nans.oe));
                printf("%I64d\n",ans);
            }
            else if(op == 1)
                update(1,n,1,a,b);
        }
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-13 01:25:42

【HDU 5316】Magician(线段树)的相关文章

hdu 5316 Magician (线段树)

题目链接: hdu 5316 Magician 题目描述: 有n个精灵,每个精灵都有一个魔法值,现在有两个操作: (0, a, b)查询[a, b]序列中的一个完美序列的最大和,完美序列就是数组中相邻数字的下标奇偶性不同. (1, a, b)更新下标为a的精灵魔法值为b. 对的,没错就是这个意思,但是比赛的时候就是题意卡的死死的有没有啊,就是各种不懂有没有啊!!! 1 #include <cstdio> 2 #include <cstring> 3 #include <ios

HDU 5316 Magician(线段树区间合并, 子序列最值 多校2015啊)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5316 Problem Description Fantasy magicians usually gain their ability through one of three usual methods: possessing it as an innate talent, gaining it through study and practice, or receiving it from an

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

HDU 1828 Picture 线段树+扫描线

题意:给你一些矩形的左上角点的坐标和右下角点的坐标,求周长并 最显而易见的思路就是对于x轴和y轴做两次扫描线,对于负数的坐标进行离散化.每次增加的值是线段变化量的绝对值.具体写法和求面积并的差不多. #include <cstdio> #include <algorithm> #include <cstring> #include <vector> using namespace std; #define lson rt << 1 , l , m

HDU 1542 Atlantis(线段树扫描线)

http://acm.hdu.edu.cn/showproblem.php?pid=1542 Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6788    Accepted Submission(s): 2970 Problem Description There are several ancient Greek

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我

hdu 1542 Atlantis(线段树&amp;扫描线&amp;面积并)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6386    Accepted Submission(s): 2814 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i

hdu 1828 Picture(线段树&amp;扫描线&amp;周长并)

Picture Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2578    Accepted Submission(s): 1363 Problem Description A number of rectangular posters, photographs and other pictures of the same shap

hdu 1542 Atlantis(线段树)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6899    Accepted Submission(s): 3022 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i

hdu 4864(2) 线段树

对task和machine的yi由小到大进行排序,然后对machine来跟task配对.当machine[].yi >= task[].yi时,就更新线段树,在1-1440上做线段树,线段树存的是task[].xi,同时用用优先队列保存task[].yi:当machine[].yi < task[].yi时,就查找 1到machine[].xi最大的值.如果存在最大值的话,把优先队列里的task[].yi取出来..这样一个machine就匹配到了一个最优的任务.还是看代码好好意会吧,细节挺多的